/* Callbacks */
void key_actions(GtkWidget *, GdkEventKey *);
void mouse_actions(GtkWidget *, GdkEventMotion *);
void buttons_callback(GtkWidget *, gpointer );
void menu_callback(GtkWidget *, gpointer );
void time_callback(GtkWidget *, gpointer );
gint configure_event_main(GtkWidget *,GdkEventConfigure *);

void predict_range(GtkWidget *,SAT *,struct tm ,struct tm );
void Create_predict_wnd(GtkWidget *);

void Update_Main(GtkWidget *);
void Update_Main_Wait(GtkWidget *);

/**/
SAT *nearest(SAT *,int,int);
SAT *get_next_sat(SAT *,struct tm *);
void select_this_sat(SAT *);
void draw_onepos(struct tm ,GtkWidget *,SAT *);
void draw_onepos_all(GtkWidget *);
int draw_curpos(gpointer);
void calc_onepos(SAT *,struct tm ,int,POINT *,POINT *,POINT *);
void calc_x2satobs(KEPLER *,ORBIT *,POINT *,POINT *,int ,float ,int );
void report_nextpass(GtkWidget *,SAT *);
int calcpossat(struct tm *,int,KEPLER *,ORBIT *,POINT *);
void calc_satobs(KEPLER *,ORBIT *,POINT *,POINT *,float );
void add_to_list(GtkWidget *,TRACK *);
char *tmstrsh();
int strcmpwild(char *,char *);

void draw_mark(GtkWidget *,POINT ,char *);
void draw_track(GtkWidget *,SAT *,struct tm ,struct tm );
void calcdraw_sensor(struct tm ,GtkWidget *,SAT *);

void calcposearth();
void calcposrel();
int read_norad_next_keps();
int calc_orbitconst();
void pri_startstop();
char *tmstrshx(struct tm *,char *);
void alloc_err();
void init_db(DBASE *,char);
int get_satkeps();
void pri_norad();
char *timestr();
void clear_wnd(GtkWidget *);
void refresh_wnd(GtkWidget *);
void select_sat(GtkWidget *);
SAT *read_msat(FILE *,char *,SAT *);
void add_to_db();
void ld_clr(GdkColor *,int ,int ,int ,int );
struct tm mom_tm();
struct tm local2gmt(struct tm *);

void draw_rast(GtkWidget *,gboolean);
void draw_ref(GtkWidget *,float ,float ,gboolean);
void draw_sat(GtkWidget *,SAT *,float ,float ,gboolean);
void draw_sensor(GtkWidget *,SAT *sat,POINT *,POINT *,gboolean);
void draw_sattrack(GtkWidget *wnd,POINT p1,POINT p2,gboolean rgbm,int p);
void draw_vis(GtkWidget *,SAT *,POINT *,gboolean);
void draw_back(GtkWidget *);
void Create_kepleredt_wnd(GtkWidget *);
void select_sat_func(GtkWidget *, gpointer );
void Remove_Widget(GtkWidget *, char *);
void update_satbut(GtkWidget *,char *,SAT *);
SAT *Create_Sat (SAT *);
SAT *find_sat(SAT *,char *);
gboolean predict(SAT *,struct tm *,struct tm *,TRACK *);
int read_norad_next_keps(FILE *,char *,KEPLER *);
int calc_orbitconst(KEPLER *,ORBIT *);
gint32 mktime_ntz(struct tm *);

void ps_hdr(FILE *);
void ps_ldr(FILE *);
void setfont(FILE *,int );
void draw_rect(FILE *,int ,int ,int ,int ,int ,gboolean );
void draw_text(FILE *,int ,int ,char *,...);
int titel(FILE *,DBASE *,int );
void ps_rast(FILE *,int ,int ,int );

void generate_ps(TRACK *,SAT *);
void fillin_satpos(char *,char *,float,float,float,float);
char *dbl_prct(char *);
int exist_file(char *);
void search_file(char *,char *,char *,char *,char *);
